"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var THREE = __importStar(require("three"));
var plane_1 = __importDefault(require("../../primitives/plane"));
var constants_1 = require("../../utils/constants");
var line_1 = __importDefault(require("../../primitives/line"));
var index_1 = require("./index");
var PickPlane = /** @class */ (function (_super) {
    __extends(PickPlane, _super);
    function PickPlane(color, width, height) {
        if (color === void 0) { color = constants_1.DEFAULT_COLOR_PLANE; }
        if (width === void 0) { width = constants_1.DEFAULT_PLANE_WIDTH; }
        if (height === void 0) { height = constants_1.DEFAULT_PLANE_HEIGHT; }
        var _this = _super.call(this) || this;
        /**
         * @hidden
         */
        _this.getInteractiveObjects = function () {
            return [_this.plane];
        };
        _this.setColor = function (color) {
            var planeMaterial = _this.plane.material;
            var boundaryMaterial = _this.boundary.material;
            planeMaterial.color.set(color);
            boundaryMaterial.color.set(color);
        };
        var boundaryGeometry = new THREE.BufferGeometry();
        var crossXGeometry = new THREE.BufferGeometry();
        var crossYGeometry = new THREE.BufferGeometry();
        var vertexMaxX = width / 2;
        var vertexMaxY = height / 2;
        boundaryGeometry.setAttribute('position', new THREE.Float32BufferAttribute([
            vertexMaxX, vertexMaxY, 0,
            vertexMaxX, -vertexMaxY, 0,
            -vertexMaxX, -vertexMaxY, 0,
            -vertexMaxX, vertexMaxY, 0
        ], 3));
        crossXGeometry.setAttribute('position', new THREE.Float32BufferAttribute([
            0, vertexMaxY, 0,
            0, -vertexMaxY, 0,
        ], 3));
        crossYGeometry.setAttribute('position', new THREE.Float32BufferAttribute([
            -vertexMaxX, 0, 0,
            vertexMaxX, 0, 0,
        ], 3));
        _this.boundary = new line_1.default(color, boundaryGeometry);
        _this.crossX = new line_1.default("black", crossXGeometry);
        _this.crossY = new line_1.default("black", crossYGeometry);
        _this.plane = new plane_1.default(color, width, height);
        _this.add(_this.plane);
        _this.add(_this.boundary);
        _this.add(_this.crossX);
        _this.add(_this.crossY);
        return _this;
    }
    return PickPlane;
}(index_1.PickPlaneGroup));
exports.default = PickPlane;
//# sourceMappingURL=pick-plane.js.map